/**
  ******************************************************************************
  * @file    main.c 
  * @author  Wangbao Dev Team
  * @version V1.0.0
  * @date    07-10-2012
  * @brief   Main program body
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */ 


#include "stm32f4xx.h"
#include "main.h"
#include "uart.h"
#include "lcd.h"
#include "ov7670.h"
#include "sccb_bus.h"



void nvic_config(void)
{	
	/* NVIC configuration */
	/* Configure the Priority Group to 2 bits */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);	
}


/**
  * @brief   Main program
  * @param  None
  * @retval None
  */
int main(void)
{
//	SD_Init(); չ
		uint16_t temp;
		nvic_config();
		uart_init();
		printf("\r\n");
		printf("hello!welcome to F4...\r\n");
	
		printf("Sensor init...	MT9D111\r\n");
		if (mt9d111_init())
		{
				printf("Init MT9D111 reg Fail...\r\n");
				while (1){}
		}
		else
		{
				printf("Init MT9D111 reg OK...\r\n");
				printf("Show Camer Data...\r\n");
				lcd_init();
				systick_delay_ms(500);
				cam_start();
		}


//	temp = ov2640_check();
//	if(temp==0x2642)
//		printf("Read Cam product ID is 0x2642,the camer is OV2640\r\n");
//	if(temp==0x7673)
//		printf("Read Cam product ID is 0x7673,the camer is OV7670\r\n");
//	
//	if (temp != 0x2642)
//	{
//		printf("Read Cam ID Fail...ID : [0x%02x]\r\n",temp);
//		while (1)
//		{}
//	}
//	else
//	{
//		printf("Cam ID : [0x%02x]\r\n",temp);
//		if (mt9d111_init())
//		{
//			printf("Init OV2640 reg Fail...\r\n");
//			while (1)
//			{}
//		}
//		else
//		{
//			printf("Init OV2640 reg OK...\r\n");
//			printf("Show Camer Data...\r\n");
//			lcd_init();
//			systick_delay_ms(500);
//			cam_start();

//		}
//		
//	}
//	while(1)
//	{
//		for(temp=0;temp<0xff;temp++)
//		{
//			ov7670_write_reg(0xff, 0x00);
//			ov7670_write_reg(0x7c, 0x00);
//			ov7670_write_reg(0x7d, 0x04);
//			ov7670_write_reg(0x7c, 0x09);
//			ov7670_write_reg(0x7d, 0x44);
//			ov7670_write_reg(0x7d, 0x00);
//			for(i=0;i<0x4ffff;i++);
			while(1);
//		}
//	}
}






#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */ 

/**
  * @}
  */ 

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
