/**
  ******************************************************************************
  * @file    ov7670.h 
  * @author  WangBao Dev Team
  * @version V1.0.0
  * @date    07-10-2012
  * @brief   Header for ov7670.c module
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */ 
 
#ifndef _OV7670_H_
#define _OV7670_H_


#include "stm32f4xx.h"

#define DCMI_DR_ADDRESS       	0x50050028   
#define FSMC_LCD_ADDRESS      	0x6C000002


//ѡͷ //Shine
#define ov7670	0
#define ov2640	0
#define mt9d111	1

   #define CHANGE_REG_NUM 154
   #define n_NUM 3

#if ov7670
uint16_t ov7670_check(void);
uint8_t ov7670_init(void);
#elif ov2640
uint16_t ov2640_check(void);
uint8_t ov2640_init(void);
#elif mt9d111
//uint16_t mt9d111_check(void);
uint8_t mt9d111_init(void);
uint8_t wrMT9D111RegBit(u8 Page, u8 regID, u16 C_Dat,u16 W_Dat);
void wrMT9D111Variables(u8 ID,u8 offset, u8 isLogical,	u8 Size, u16 value);
void rdMT9D111Variables(u8 ID,u8 offset, u8 isLogical,	u8 Size, u16* value);
void JPEG_OutConfigure(u16 width, u16 height,u8 format,int restart_int);
#endif

void cam_start(void);


#endif /* _OV7670_H_ */

/******************* (C) COPYRIGHT 2012 WangBao *****END OF FILE****/
